function File(nsFile) {
	if(nsFile.constructor == String)
		this.filename = nsFile;
	else
		this.file = nsFile;
};

File.prototype.createRow = function(obj) {
	var file = this;

	var strings = document.getElementById("bundleloop");

	var main = this.createElement('vbox');
	main.flex = 1;
	var content = this.createElement('hbox');
	content.flex = 1;
	content.align = 'center';
	var controls = this.createElement('vbox', {
		'class': 'file-controls'
	});
	
	this.download = this.createElement('image', {
		'src':      (this.download ? this.download.getAttribute('src') : 'chrome://fireloop/skin/throbber.gif'),
		'class':    'text-link',
		'disabled': 'true'
	});
	var name = (this.filename ? this.filename : this.file.leafName);
	this.setDescription(name);
	
	this.open = this.createElement('label', {
		'value': strings.getString("open.file"),
		'style': (this.open ? this.open.getAttribute('style') : 'visibility: hidden;'),
		'disabled': (this.open ? this.open.disabled : true),
		'class': 'text-link'
	});
	this.remove = this.createElement('label', {
		'value': (this.remove ? this.remove.value : strings.getString("cancel.file")),
		'class': 'text-link'
	});
	
	this.row = this.createElement('richlistitem', {
		'class': 'rli'
	});
	
	controls.appendChild(this.open);
	controls.appendChild(this.remove);
	
	content.appendChild(this.download);
	content.appendChild(this.description);
	var newatt = {'flex': 1};
	var newel = this.createElement('spacer', newatt);
	content.appendChild(newel);
	content.appendChild(controls);
	
	main.appendChild(content);
	if(this.error)
		main.appendChild(this.error)
	
	this.main = main;
	
	this.row.appendChild(this.main);
	this.row.owner = this;

	this.attachEvents();

	obj.appendChild(this.row);
};

File.prototype.attachEvents = function() {
	var file = this;
    
	this.remove.onclick = function(e) { 
        if (!this.disabled) {
            file.removeRow(true); 
        }
        e.stopPropagation();
    };
	if(this.downloadclick) {
		this.download.onclick = this.open.onclick = function(e){ file.downloadclick(e); };
	}
	
	this.row.onkeypress = function(event) { handle_enter("download_command", event); }
};

File.prototype.createElement = function(type, attributes) {
	var b = document.createElement(type);
	if(attributes) {
		for(var key in attributes) {
			if(key.constructor == String && attributes[key].constructor == String) {
				b.setAttribute(key, attributes[key]);
			}
		}
	}
	return b;
};

File.prototype.downloadPDF = function() {
	var url = "http://"+loop.domain+"/files/"+encodeURIComponent((this.filename ? this.filename : this.file.leafName))+"/PDF?i="+loop.Interface;
	var windowManager = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService();
	var windowManagerInterface = windowManager.QueryInterface(Components.interfaces.nsIWindowMediator);
	var topWindow = windowManagerInterface.getMostRecentWindow('navigator:browser');
	var browser = topWindow.document.getElementById("content");
	browser.loadURI(url,null,null);
};

File.prototype.removeRow = function(deleteFromServer) {
	this.row.parentNode.removeChild(this.row);
	if(deleteFromServer) {
		if(this.uploadRequest && this.uploadRequest.readyState != 4) {
			this.uploadRequest.abort();
		}
		var xmlr = new XMLHttpRequest();
		xmlr.open("DELETE", "http://"+loop.domain+"/files/"+encodeURIComponent((this.filename?this.filename:this.file.leaf))+"/?i="+loop.Interface, true);
		xmlr.send(null);
	}
	if(this.updateCallback)
		this.updateCallback();
};

File.prototype.upload = function() {
	if (!this.isSupported())
    {
        this.updateRow("File type unsupported.");
        return;
    }
    var name = (this.filename ? this.filename : this.file.leafName);
	/*
    if(name.indexOf("%") != -1 || name.indexOf("%25") != -1) {
		this.updateRow();
		return;
	}
    */
	const BOUNDARY = "111222333222111";

	const MULTI    = "@mozilla.org/io/multiplex-input-stream;1";
	const FINPUT   = "@mozilla.org/network/file-input-stream;1";
	const STRINGIS = "@mozilla.org/io/string-input-stream;1";
	const BUFFERED = "@mozilla.org/network/buffered-input-stream;1";

	const nsIMultiplexInputStream = Components.interfaces.nsIMultiplexInputStream;
	const nsIFileInputStream      = Components.interfaces.nsIFileInputStream;
	const nsIStringInputStream    = Components.interfaces.nsIStringInputStream;
	const nsIBufferedInputStream  = Components.interfaces.nsIBufferedInputStream;

	var fileUpload = Components.classes[MULTI].createInstance(nsIMultiplexInputStream);

	var headerStream = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
	var requestHeader = new String();
	requestHeader += "Content-Type: multipart/form-data, boundary=" + BOUNDARY;
	requestHeader += "\r\n";
	requestHeader += "Content-Length: " + this.file.fileSize;
	requestHeader += "\r\n\r\n";
	headerStream.setData(requestHeader, requestHeader.length);

	fileUpload.appendStream(headerStream);
	
	var fileHeaderStream = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
	var fileHeader = new String();
	fileHeader += "\r\n\r\n--" + BOUNDARY + "\r\n";
	fileHeader += "Content-Disposition: form-data; name=\"" + this.file.leafName + "\"; filename=\"" + this.file.leafName + "\"\r\n";

    var mimeType = "";
    try {
        mimeType = Components.classes["@mozilla.org/mime;1"].getService(Components.interfaces.nsIMIMEService).getTypeFromFile(this.file);
    }
    catch (ex) {
        mimeType = "application/octet-stream";
    }
    fileHeader += "Content-Type: " + mimeType + "\r\n";
	fileHeader += "Content-Transfer-Encoding: binary\r\n\r\n";
	//fileHeaderStream.setData(fileHeader, fileHeader.length);
	
	//convert to UTF-8 to handle special characters properly
	var converter = Components.classes["@mozilla.org/intl/scriptableunicodeconverter"]
		.createInstance(Components.interfaces.nsIScriptableUnicodeConverter);
	converter.charset = "UTF-8";
	fileHeaderStream = converter.convertToInputStream(fileHeader);
	
	var fileStream = Components.classes[FINPUT].createInstance(nsIFileInputStream);
	fileStream.init(this.file, 0x01, 0444, null);
	var fileBuffer = Components.classes[BUFFERED].createInstance(nsIBufferedInputStream);
	fileBuffer.init(fileStream, 4096);

	fileUpload.appendStream(fileHeaderStream);
	fileUpload.appendStream(fileBuffer);

	var footerStream = Components.classes[STRINGIS].createInstance(nsIStringInputStream);
	var requestFooter = new String("\r\n--" + BOUNDARY + "--\r\n");
	footerStream.setData(requestFooter, requestFooter.length);
	fileUpload.appendStream(footerStream);
	var file = this;
	
	var xmlr = new XMLHttpRequest();
	xmlr.onreadystatechange = function() {
		file.uploadResults(xmlr);
	};
	var url = "http://"+loop.domain+"/files?i="+loop.Interface;
	xmlr.open("POST", url, true);
	xmlr.setRequestHeader("Content-Length", fileUpload.available() - 2 );
	xmlr.setRequestHeader("Content-Type", "multipart/form-data; boundary=" + BOUNDARY);
	file.uploadRequest = xmlr;
	xmlr.send(fileUpload);
};

File.prototype.uploadResults = function(xmlr) {
	this.status = 'failed';
	var file = this;
	var strings = document.getElementById("bundleloop");
	
	if(xmlr.readyState == 4) {
        //if 'cancel' is hidden (uploading url), show it
        this.remove.disabled = false;    
		if(xmlr.status == 403 || (xmlr.getResponseHeader("Content-Location") && xmlr.getResponseHeader("Content-Location").toLowerCase().indexOf("error") > -1)) {
			file.status = 'error';
			file.download.setAttribute('src', 'chrome://fireloop/skin/error.png');
			file.downloadclick = function(e){ alert(strings.getString('problem.upload')); e.stopPropagation(); };
			file.download.onclick = function(e) { file.downloadclick(); e.stopPropagation(); };
            file.filename = 'Bad Url';
            file.error = file.createElement('label', {
                'value': strings.getString('problem.upload')
            });
            file.main.appendChild(file.error);
			file.remove.value = strings.getString("remove.file");
		} else {
			// check file
			var filename = $utf8.decode(xmlr.getResponseHeader("Files-Processed"));	
            var redundantMsgs = filename.split(", ");
            if (redundantMsgs.length == 2 && redundantMsgs[0] == redundantMsgs[1])
                filename = redundantMsgs[0];
			filename = filename.substr(0, filename.length-1);
			file.filename = filename;
            file.setDescription(filename);
			file.updateRow();
		}
	}
	this.completed = true;
};

File.prototype.updateRow = function(error) {
	var request = new XMLHttpRequest();
	var file = this;
	var name = (file.filename ? file.filename : file.file.leafName);
    /*
	if(name.indexOf("%") != -1 || name.indexOf("%25") != -1) {
		file.status = 'error';
		file.download.setAttribute('src', 'chrome://fireloop/skin/error.png');
		file.main.appendChild(this.createElement('label', {
			'value': 'illegal character in file path: %'
		}));
		var strings = document.getElementById("bundleloop");
		file.remove.value = strings.getString("remove.file");
		if(file.updateCallback)
			file.updateCallback();
	} 
    else*/ if (error && typeof(error) == 'string'){
    	file.status = 'error';
		file.download.setAttribute('src', 'chrome://fireloop/skin/error.png');
		file.main.appendChild(this.createElement('label', {
			'value': error
		}));
		var strings = document.getElementById("bundleloop");
		file.remove.value = strings.getString("remove.file");
		if(file.updateCallback)
			file.updateCallback();
    } else {
		var url = "http://"+loop.domain+"/files/"+encodeURIComponent(name)+"/status?i="+loop.Interface;
		request.open("GET", url, true);
		request.send(null);
		request.onreadystatechange = function(){
			if(request.readyState == 4) {
				var response = request.responseXML.documentElement;
				var messages = response.getElementsByTagName('message');
				var messagestring = "";
				for(var i = 0; i < messages.length; i++) {
					messagestring += messages[i].firstChild.data + "; ";
				}             
				file.completed = true;
				var strings = document.getElementById("bundleloop");
				file.remove.value = strings.getString("remove.file");
				if(messagestring == "Completed.; ") {
					file.status = 'ok';
					file.download.setAttribute('src', 'chrome://fireloop/skin/download.png');
					file.downloadclick = function(e){ this.downloadPDF(); e.stopPropagation(); };
					file.download.onclick = file.open.onclick = function(e){ file.downloadclick(e); };
					file.open.setAttribute('style', 'visibility: visible;'); 
					file.open.disabled = false;
				} else {
					file.status = 'error';
					file.download.setAttribute('src', 'chrome://fireloop/skin/error.png');
					file.error = file.createElement('label', {
						'value': messagestring.substring(0, messagestring.length-2)
					});
					file.main.appendChild(file.error);
				}
			}
			if(file.updateCallback)
				file.updateCallback();
		}
	}
};

File.prototype.isSupported = function() {
	var name = (this.filename ? this.filename : this.file.leafName);
    var ext = name.substring(name.lastIndexOf(".")).toLowerCase();
    switch (ext)
    {
        case ".bmp":
        case ".css":
        case ".doc":
        case ".docx":
        case ".gif":
        case ".htm":
        case ".html":
        case ".jpg":
        case ".jpeg":
        case ".mdi":
        case ".mht":
        case ".pdf":
        case ".png":
        case ".ppt":
        case ".pptx":
        case ".pub":
        case ".rtf":
        case ".tif":
        case ".tiff":
        case ".txt":
        case ".vsd":
        case ".wpd":
        case ".wps":
        case ".xls":
        case ".xlsx":
        case ".xml":
            return true;
            break;
        default:
            return false;
    }
};
    
File.prototype.setDescription = function(name) {
    if(name.length > 37)
        name = name.substring(0, 34)+"...";
    if (!this.description)
    {
    	this.description = this.createElement('description', {
    		'value': name
    	});
    	this.description.flex = 1;
    }
    else
        this.description.value = name;
};